<?php
/**
 * Curse Inc.
 * Admin Minder
 * Keeps track of admins added and removed over time on Hydra wikis
 *
 * @author		Noah Manneschmidt
 * @copyright	(c) 2014 Curse Inc.
 * @license		GNU General Public License v2.0 or later
 * @package		AdminMinder
 * @link		https://gitlab.com/hydrawiki
 *
**/
namespace AdminMinder;

/**
 * Functions for reading and writing rows in the admin_minder_admins table
 */
class AdminList {
	/**
	 * Get the cached version of the administrator list previously generated by getCurrentAdmins().
	 *
	 * @return array
	 */
	public static function getCachedAdmins() {
		$db = wfGetDB(DB_SLAVE);
		$res = $db->select(
			['admin_minder_admins'],
			['*'],[],
			__METHOD__
		);
		$adminList = [];

		while ($row = $res->fetchRow()) {
			$roles = unserialize($row['groups']);

			if (count($roles)) {
				$adminList[$row['global_id']][$row['site_key']] = $roles;
			}
		}
		$res->free();

		return $adminList;
	}

	/**
	 * Get cached count of administrators.
	 *
	 * @return integer
	 */
	public static function getCachedAdminsCount() {
		$db = wfGetDB(DB_SLAVE);
		$res = $db->select(
			['admin_minder_admins'],
			['COUNT(*)'],[],
			__METHOD__
		);
		
		$totalCount = 0;

		while ($row = $res->fetchRow()) {
			$totalCount = $row['COUNT(*)']; 
			continue;
		}
		$res->free();

		return intval($totalCount);
	}

	/**
	 * Get current administrator list from all wikis.
	 *
	 * @param \SyncService\OutputShim $logger
	 * @return array
	 */
	public static function getCurrentAdmins(\SyncService\ILogger $logger) {
		switch ($_SERVER['PHP_ENV']) {
			case 'production':
				$domainField = \DynamicSettings\Wiki\Domains::ENV_PRODUCTION;
				break;
			case 'staging':
				$domainField = \DynamicSettings\Wiki\Domains::ENV_STAGING;
				break;
			case 'development':
			default:
				$domainField = \DynamicSettings\Wiki\Domains::ENV_DEVELOPMENT;
				break;
		}

		$db = wfGetDB(DB_SLAVE);
		$res = $db->select(
			[
				'wiki_sites',
				'wiki_domains'
			],
			[
				'wiki_sites.md5_key',
				'wiki_domains.domain AS wiki_domain'
			],
			[
				'deleted' => 0,
				'wid > 1',
				'wiki_domains.type' => $domainField
			],
			__METHOD__,
			[],
			[
				'wiki_domains' => [
					'LEFT JOIN', 'wiki_domains.site_key = wiki_sites.md5_key'
				]
			]
		);
		$adminList = [];

		// get current list of all admins
		while ($row = $res->fetchRow()) {
			$json = @file_get_contents("http://{$row['wiki_domain']}/api.php?action=admins&do=list&format=json&formatversion=2");
			if (!$json) {
				$logger->outputLine("Skipping {$row['wiki_domain']} due to empty response", time());
				continue;
			}
			$apiResult = json_decode($json, true);
			if (is_null($apiResult) || empty($apiResult['admins'])) {
				$logger->outputLine("No admin data given from {$row['wiki_domain']}", time());
				continue;
			}
			foreach ($apiResult['admins'] as $globalId => $roles) {
				$adminList[$globalId][$row['md5_key']] = $roles;
			}
			$logger->outputLine("Downloaded ".count($apiResult['admins'])." from {$row['wiki_domain']}", time());
		}
		$res->free();

		return $adminList;
	}

	public static function getEmailList() {
		$db = wfGetDB(DB_SLAVE);
		$result = $db->select(
			['admin_minder_admins'],
			['*'],
			[],
			__METHOD__,
			['GROUP BY' => 'admin_minder_admins.global_id']
		);

		$lookup = \CentralIdLookup::factory();

		$emails = [];
		while ($row = $result->fetchRow()) {
			$user = $lookup->localUserFromCentralId($row['global_id']);
			if ($user && $user->getId()) {
				$emails[] = sprintf('%s <%s>', $user->getName(), $user->getEmail());
			}
		}

		return implode(', ', $emails);
	}

	/**
	 * Overwrite the entire cached admin list with the given array
	 *
	 * @param	array	list of admins in the format returned by getCurrentAdmins
	 * @return	void
	 */
	public static function saveNewAdmins($admins) {
		$db = wfGetDB(DB_MASTER);
		$db->delete('admin_minder_admins', '*');

		foreach ($admins as $globalId => $wikis) {
			foreach ($wikis as $md5Key => $groups) {
				if (empty($groups)) {
					continue;
				}
				$db->insert(
					'admin_minder_admins',
					[
						'site_key' => $md5Key,
						'global_id' => $globalId,
						'groups' => serialize($groups)
					],
					__METHOD__
				);
			}
		}
	}
}
